//+------------------------------------------------------------------+
//|                                      MQL5 Struct General lib.mqh |
//|                                 Copyright 2007-2013, JQS aka Joo |
//|                              https://login.mql5.com/ru/users/joo |
//+------------------------------------------------------------------+
#property copyright "Copyright 2011, JQS aka Joo"
#property link      "https://login.mql5.com/ru/users/joo"


//       40 .
//     4- .
struct MqlArrayObject
  {
   ushort            type;            //   
   ushort            flags;           // ,  
   uint              item_len;        //      
   int               allocated;       //  ,   
   int               range0;          //    (  0)
   int               range1;          //   ,  .  0
   int               range2;          //   ,  .  0
   int               range3;          //   ,  .  0
   int               reserved0;       //  
   int               reserved1;       // 
   int               reserved2;       // 
  };


//,     .
struct MqlBookInfo
  {
   ENUM_BOOK_TYPE    type;             //     ENUM_BOOK_TYPE
   double            price;            // 
   long              volume;           // 
  };

//        int.
struct MqlDateTime
  {
   int               year;             // 
   int               mon;              // 
   int               day;              // 
   int               hour;             // 
   int               min;              // 
   int               sec;              // 
   int               day_of_week;      //   (0-, 1-, ... ,6-)
   int               day_of_year;      //     (1    0)
  };


// MqlParam              IndicatorCreate().
struct MqlParam
  {
   ENUM_DATATYPE     type;             //   ,   ENUM_DATATYPE
   long              integer_value;    //     
   double            double_value;     //     double  float
   string            string_value;     //      
  };


//     ,   .
struct MqlRates
  {
   datetime          time;             //   
   double            open;             //  
   double            high;             //    
   double            low;              //    
   double            close;            //  
   long              tick_volume;      //  
   int               spread;           // 
   long              real_volume;      //  
  };


//      .          .
struct MqlTick
  {
   datetime          time;             //    
   double            bid;              //   Bid
   double            ask;              //   Ask
   double            last;             //     (Last)
   ulong             volume;           //     Last
  };


//        , 
//   .    OrderCheck(), 
//         MqlTradeCheckResult. 
//       .
struct MqlTradeCheckResult
  {
   uint              retcode;          //  
   double            balance;          //    
   double            equity;           //    
   double            profit;           //  
   double            margin;           //  
   double            margin_free;      //  
   double            margin_level;     //  
   string            comment;          //     ( )
  };


//         
//    IndicatorCreate().
struct MqlParam
  {
   ENUM_DATATYPE     type;             //   ,   ENUM_DATATYPE
   long              integer_value;    //     
   double            double_value;     //     double  float
   string            string_value;     //      
  };


//         
//     .   
//   MqlTradeRequest,    , 
//    .     
// MqlTradeResult.
struct MqlTradeRequest
  {
   ENUM_TRADE_REQUEST_ACTIONS action;   //   
   ulong             magic;             //   ( magic number)
   ulong             order;             //  
   string            symbol;            //   
   double            volume;            //     
   double            price;             // 
   double            stoplimit;         //  StopLimit 
   double            sl;                //  Stop Loss 
   double            tp;                //  Take Profit 
   ulong             deviation;         //      
   ENUM_ORDER_TYPE   type;              //  
   ENUM_ORDER_TYPE_FILLING type_filling;//    
   ENUM_ORDER_TYPE_TIME type_time;      //     
   datetime          expiration;        //    (   ORDER_TIME_SPECIFIED)
   string            comment;           //   
  };


//         ,   
// ,       
//      MqlTradeResult.
struct MqlTradeResult
  {
   uint              retcode;          //   
   ulong             deal;             //  ,   
   ulong             order;            //  ,   
   double            volume;           //  ,  
   double            price;            //   ,  
   double            bid;              //     ( )
   double            ask;              //     ( )
   string            comment;          //     (   )
   uint              request_id;       //  ,    
  };


//       ,   .    :
//
//    MQL5-       OrderSend  OrderSendAsync    ; 
//          ; 
//    -  ; 
//     . 
//        :
//
//  ; 
//  ; 
//  ; 
//  ; 
// . 
//,        ,       ,   ,     ,    ,          .      .
//
//   ,   ,  MQL5    OnTradeTransaction().        MqlTradeTransaction,   .
struct MqlTradeTransaction
  {
   ulong             deal;             //  
   ulong             order;            //  
   string            symbol;           //   
   ENUM_TRADE_TRANSACTION_TYPE type;   //   
   ENUM_ORDER_TYPE   order_type;       //  
   ENUM_ORDER_STATE  order_state;      //  
   ENUM_DEAL_TYPE    deal_type;        //  
   ENUM_ORDER_TYPE_TIME type_time;     //     
   datetime          time_expiration;  //   
   double            price;            // 
   double            price_trigger;    //   - 
   double            price_sl;         //  Stop Loss
   double            price_tp;         //  Take Profit
   double            volume;           //   
  };
